crypton-1.0.1: Cryptography Primitives sink

License | BSD-style
Maintainer | Olivier Chéron <olivier.cheron@gmail.com>
Stability | experimental
Portability | unknown
Safe Haskell | None
Language | Haskell2010

Crypto.System.CPU

Description

Gives information about crypton runtime environment.

Synopsis

- data ProcessorOption
  - = AESNI
  - | PCLMUL
  - | RDRAND
- processorOptions :: [ProcessorOption]

# Documentation

data ProcessorOption #

CPU options impacting cryptography implementation and library performance.

Constructors

AESNI | Support for AES instructions, with flag `support_aesni`
PCLMUL | Support for CLMUL instructions, with flag `support_pclmuldq`
RDRAND | Support for RDRAND instruction, with flag `support_rdrand`

#### Instances

Instances details

Data ProcessorOption # |

Instance details

Defined in Crypto.System.CPU

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> ProcessorOption -> c ProcessorOption #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c ProcessorOption #

toConstr :: ProcessorOption -> Constr #

dataTypeOf :: ProcessorOption -> DataType #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c ProcessorOption) #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c ProcessorOption) #

gmapT :: (forall b. Data b => b -> b) -> ProcessorOption -> ProcessorOption #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> ProcessorOption -> r #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> ProcessorOption -> r #

gmapQ :: (forall d. Data d => d -> u) -> ProcessorOption -> [u] #

gmapQi :: Int -> (forall d. Data d => d -> u) -> ProcessorOption -> u #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> ProcessorOption -> m ProcessorOption #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> ProcessorOption -> m ProcessorOption #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> ProcessorOption -> m ProcessorOption #

Enum ProcessorOption # |

Instance details

Defined in Crypto.System.CPU

Methods

succ :: ProcessorOption -> ProcessorOption #

pred :: ProcessorOption -> ProcessorOption #

toEnum :: Int -> ProcessorOption #

fromEnum :: ProcessorOption -> Int #

enumFrom :: ProcessorOption -> [ProcessorOption] #

enumFromThen :: ProcessorOption -> ProcessorOption -> [ProcessorOption] #

enumFromTo :: ProcessorOption -> ProcessorOption -> [ProcessorOption] #

enumFromThenTo :: ProcessorOption -> ProcessorOption -> ProcessorOption -> [ProcessorOption] #

Show ProcessorOption # |
Instance details Defined in Crypto.System.CPU Methods showsPrec :: Int -> ProcessorOption -> ShowS # show :: ProcessorOption -> String # showList :: [ProcessorOption] -> ShowS #
Eq ProcessorOption # |
Instance details Defined in Crypto.System.CPU Methods (==) :: ProcessorOption -> ProcessorOption -> Bool # (/=) :: ProcessorOption -> ProcessorOption -> Bool #

processorOptions :: [ProcessorOption] #

Options which have been enabled at compile time and are supported by the current CPU.